/* 
 * Lexical scanner for program's run control file
 * 2002-2003 HShivanan
 * 
 * For licensing terms, see the file COPYING
 * For contact information, see the file AUTHORS
 *
 */

#include <string.h>
#include "configscan.h"
#include "stuff.h"
#define SCAN_CONFIG
#include "scan.h"
#undef SCAN_CONFIG
static void scancomment(CONFIG_SCANNER *scanner)
{
	nextchar(scanner);
	while(1)
	{
		nextchar(scanner);
		if (scanner->ahead==13||scanner->ahead==10||scanner->ahead==0) break;
	}
	scanner->tokenid=COMMENT;
	nextchar(scanner);

}

static void scanstring(CONFIG_SCANNER *scanner)
{
	scanner->tokenid=STRING;
	nextchar(scanner);
	while(1)
	{
		if (scanner->ahead=='"')
		{
			nextchar(scanner);
			break;
		}
		nextchar(scanner);
		if (scanner->ahead==0)break;
	}
}



static void scannumber(CONFIG_SCANNER *scanner)
{
	scanner->tokenid=NUMBER;
	nextchar(scanner);

	while (isnum(scanner->ahead))nextchar(scanner);
	
	if (scanner->ahead=='.')
		if (isnum(scanner->code[1]))
		{
			scanner->tokenid=FLOAT;
			nextchar(scanner);
			while (isnum(scanner->ahead))nextchar(scanner);
		}

}
static void scancolon(CONFIG_SCANNER *scanner)
{
	scanner->tokenid=COLON;
	nextchar(scanner);
}
static void scanequal(CONFIG_SCANNER *scanner)
{
	scanner->tokenid=EQUAL;
	nextchar(scanner);
}
static void scanbraceopen(CONFIG_SCANNER *scanner)
{
	scanner->tokenid=BRACEOPEN;
	nextchar(scanner);
}
static void scanbraceclose(CONFIG_SCANNER *scanner)
{
	scanner->tokenid=BRACECLOSE;
	nextchar(scanner);
}
static void scanparenopen(CONFIG_SCANNER *scanner)
{
	scanner->tokenid=PARENOPEN;
	nextchar(scanner);
}
static void scanparenclose(CONFIG_SCANNER *scanner)
{
	scanner->tokenid=PARENCLOSE;
	nextchar(scanner);
}
#define register_(x,y) if (!strcmp(scanner->token,x))scanner->tokenid=y
static void scanident(CONFIG_SCANNER *scanner)
{
	scanner->tokenid=DEFAULT;
	nextchar(scanner);
	
	while (isalphanum(scanner->ahead)||(scanner->ahead == '-'))nextchar(scanner);
	scanner->token[scanner->count]=0;
	register_("title", SCORE_TITLE);
	register_("description", SCORE_DESCRIPTION);
	register_("channel", SCORE_CHANNEL);
	register_("link", SCORE_LINK);
	register_("set", SET);
    
}
static void scancomma(CONFIG_SCANNER *scanner)
{
	scanner->tokenid=COMMA;
	nextchar(scanner);
}
static void scannull(CONFIG_SCANNER *scanner)
{
	scanner->tokenid=_NULL;
}
void scandef(CONFIG_SCANNER *scanner)
{
	scanner->tokenid=ERROR;
	nextchar(scanner);
}

void _config_nexttoken(CONFIG_SCANNER *scanner)
{
	scanner->token[0]=scanner->count=0;
	scanner->ahead=*scanner->code;
	if (iswhitespace(scanner,scanner->ahead)) eatwhitespace(scanner);
	if (isnum(scanner->ahead)) scannumber(scanner); else
	if (isalphanum(scanner->ahead)) scanident(scanner); else
	switch (scanner->ahead)
	{
		case ':':scancolon(scanner);break;
		case '=':scanequal(scanner);break;
		case '[':scanbraceopen(scanner);break;
		case ']':scanbraceclose(scanner);break;
		case '(':scanparenopen(scanner);break;
		case ')':scanparenclose(scanner);break;
		case '#':scancomment(scanner);break;
 		case 0  :scannull(scanner);break;
 		case '"':scanstring(scanner);break;
		case ',':scancomma(scanner);break;
		default: scandef(scanner);
	}
	scanner->token[scanner->count]=0;
}

void config_nexttoken(CONFIG_SCANNER *scanner)
{
	_config_nexttoken(scanner);
	if (scanner->tokenid==COMMENT)
		while ((scanner->tokenid==COMMENT)&&(scanner->tokenid!=_NULL))
			_config_nexttoken(scanner);
}
